using System;
using System.Reflection;
using Kodama.Aop.Pointcut.Compose;

namespace Kodama.Aop.Pointcut.Compose.Class
{
    /// <summary>
    /// ŃNXtB^OPointcut
    /// </summary>
    /// <seealso cref="Kodama.Aop.Weaver.AspectWeaver"/>
    /// <seealso href="http://aopalliance.sourceforge.net/doc/index.html">AOP Alliance</seealso>
    public class ClassAttributePointcut : ComposiblePointcut
    {
        /// <summary>
        /// tB^O鑮
        /// </summary>
        private Type attributeType;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="attrType">tB^O鑮</param>
        public ClassAttributePointcut(Type attrType)
        {
            attributeType = attrType;
        }

        /// <summary>
        /// w肳ꂽ\bhAXyNg̑ΏۂƂȂ邩`FbN܂
        /// </summary>
        /// <param name="method">`FbN郁\bh</param>
        /// <returns>w肳ꂽ\bhAXyNg̑ΏۂƂȂ邩ǂ</returns>
        public override bool IsApplied(MethodBase method)
        {
            return Attribute.IsDefined(method.ReflectedType, attributeType);
        }
    }
}
