using System;
using System.Reflection;
using Kodama.Aop.Pointcut;
using Kodama.Aop.Pointcut.Compose.Operator;

namespace Kodama.Aop.Pointcut.Compose
{
    /// <summary>
    /// _Zɂ鍇\Pointcut
    /// </summary>
    /// <seealso cref="Kodama.Aop.Weaver.AspectWeaver"/>
    /// <seealso href="http://aopalliance.sourceforge.net/doc/index.html">AOP Alliance</seealso>
    public abstract class ComposiblePointcut : IPointcut
    {
        /// <summary>
        /// w肳ꂽ\bhAXyNg̑ΏۂƂȂ邩`FbN܂
        /// </summary>
        /// <param name="method">`FbN郁\bh</param>
        /// <returns>w肳ꂽ\bhAXyNg̑ΏۂƂȂ邩ǂ</returns>
        public abstract bool IsApplied(MethodBase method);

        /// <summary>
        /// Pointcut̘_𔽓]܂
        /// </summary>
        /// <param name="pointcut">_𔽓]Pointcut</param>
        /// <returns>_]ꂽPointcut</returns>
        public static ComposiblePointcut operator ! (ComposiblePointcut pointcut)
        {
            return new NotPointcut(pointcut);
        }

        /// <summary>
        /// 2Pointcut̘_ZandƂPointcutԂ܂
        /// </summary>
        /// <param name="left">EӒlPointcut</param>
        /// <param name="right">ӒlPointcut</param>
        /// <returns>2Pointcut̘_ZandƂPointcut</returns>
        public static ComposiblePointcut operator & (ComposiblePointcut left, ComposiblePointcut right)
        {
            return new AndPointcut(left, right);
        }

        /// <summary>
        /// 2Pointcut̘_ZorƂPointcutԂ܂
        /// </summary>
        /// <param name="left">EӒlPointcut</param>
        /// <param name="right">ӒlPointcut</param>
        /// <returns>2Pointcut̘_ZorƂPointcut</returns>
        public static ComposiblePointcut operator | (ComposiblePointcut left, ComposiblePointcut right)
        {
            return new OrPointcut(left, right);
        }
    }
}
