using System;
using Kodama.DependencyInjection.Container;
using Kodama.DependencyInjection.Component;

namespace Kodama.DependencyInjection.Marker
{
    /// <summary>
    /// R|[lg̎o^ɑΉR|[lgɕt鑮
    /// </summary>
    [AttributeUsage(AttributeTargets.Class)]
    public class AutoRegistratonComponentAttribute : Attribute
    {
        /// <summary>
        /// o^R|[lg̃JeS
        /// </summary>
        /// <remarks>
        /// ɂ莩o^R|[lgIʂ邱Ƃł
        /// </remarks>
        private string componentCategory;

        /// <summary>
        /// o^R|[lg̃CX^X
        /// </summary>
        private ComponentInstanceMode instanceMode;

        /// <summary>
        /// D悵Ċ蓖ĂC^[tFCX̌^
        /// </summary>
        private Type interfaceType;

        /// <summary>
        /// o^R|[lg̖O
        /// </summary>
        private string componentName;

        /// <summary>
        /// o^R|[lg̃JeS
        /// </summary>
        /// <remarks>
        /// ɂ莩o^R|[lgIʂ邱Ƃł
        /// </remarks>
        public string ComponentCategory
        {
            get { return componentCategory; }
        }

        /// <summary>
        /// o^R|[lg̃CX^X
        /// </summary>
        /// <remarks>
        /// ̖̑OtƂėp܂
        /// </remarks>
        public ComponentInstanceMode InstanceMode
        {
            get { return instanceMode; }
            set { instanceMode = value; }
        }

        /// <summary>
        /// D悵Ċ蓖ĂC^[tFCX̌^
        /// </summary>
        /// <remarks>
        /// ̖̑OtƂėp܂
        /// </remarks>
        public Type InterfaceType
        {
            get { return interfaceType; }
            set { interfaceType = value; }
        }

        /// <summary>
        /// o^R|[lg̖O
        /// </summary>
        /// <remarks>
        /// ̖̑OtƂėp܂
        /// </remarks>
        public string ComponentName
        {
            get { return componentName; }
            set { componentName = value; }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="category">R|[lg̃JeS</param>
        public AutoRegistratonComponentAttribute(string category)
		{
            componentCategory = category;
            instanceMode      = ComponentInstanceMode.Prototype;
            interfaceType     = null;
            componentName     = null;
		}

        /// <summary>
        /// R|[lgReiɓo^
        /// </summary>
        /// <param name="container">R|[lgo^Rei</param>
        /// <param name="type">o^R|[lg</param>
        public void Register(IMutableComponentContainer container, Type type)
        {
            IComponentEntry entry = null;
            switch (instanceMode)
            {
                case ComponentInstanceMode.Prototype :
                    if (componentName == null)
                    {
                        entry = new PrototypeComponentEntry(container, type);
                    }
                    else
                    {
                        entry = new PrototypeComponentEntry(container, type, componentName);
                    }
                    break;
                case ComponentInstanceMode.Singleton :
                    if (componentName == null)
                    {
                        entry = new SingletonComponentEntry(container, type);
                    }
                    else
                    {
                        entry = new SingletonComponentEntry(container, type, componentName);
                    }
                    break;
                default :
                    throw new InvlidComponentInstanceModeException();
            }

            if (interfaceType == null)
            {
                container.Register(entry);
            }
            else
            {
                container.Register(interfaceType, entry);
            }
        }
    }
}
