using System;
using System.Reflection;
using Kodama.Function.Functor;
using Kodama.Function.Functor.Bind;
using Kodama.Function.Functor.Member;

namespace Kodama.Function.Functor.Bind
{
    /// <summary>
    /// oChꂽRXgN^A\bh擾邽߂̃[eBeB
    /// </summary>
    public class BindUtility
    {
        /// <summary>
        /// w肳ꂽp[^ňoChꂽRXgN^Ԃ
        /// </summary>
        /// <param name="type">oChRXgN^^</param>
        /// <param name="arguments">oChp[^</param>
        /// <returns>oChꂽRXgN^</returns>
        /// <exception cref="UnmatchArgumentException">
        /// w肳ꂽp[^ŃRXgN^oChłȂꍇɔO
        /// </exception>
        public static BindFunctor CreateBindConstructor(Type type, params object[] arguments)
        {
            foreach (ConstructorInfo ci in type.GetConstructors())
            {
                if (IsCompatibleArguments(ci, arguments))
                {
                    return new BindFunctor(new ConstructorFunctor(ci), arguments);
                }
            }

            throw new UnmatchArgumentException();
        }

        /// <summary>
        /// w肳ꂽp[^ňoChꂽ\bhԂ
        /// </summary>
        /// <param name="type">oCh郁\bh^</param>
        /// <param name="name">oCh郁\bh</param>
        /// <param name="arguments">oChp[^</param>
        /// <returns>oChꂽ\bh</returns>
        /// <exception cref="UnmatchArgumentException">
        /// w肳ꂽp[^Ń\bhoChłȂꍇɔO
        /// </exception>
        public static BindFunctor CreateBindMember(Type type, string name, params object[] arguments)
        {
            object[] offsetArguments = new object[arguments.Length - 1];
            Array.Copy(arguments, 1, offsetArguments, 0, offsetArguments.Length);

            if (!type.IsAssignableFrom(arguments[0].GetType()))
            {
                throw new UnmatchArgumentException();
            }

            foreach (MethodInfo mi in type.GetMethods())
            {
                if (string.Compare(mi.Name, name) != 0)
                {
                    continue;
                }
                if (IsCompatibleArguments(mi, offsetArguments))
                {
                    return new BindFunctor(new MemberFunctor(mi), arguments);
                }
            }

            throw new UnmatchArgumentException();
        }

        /// <summary>
        /// w肳ꂽ\bhw肳ꂽp[^ňoCh\ǂ肷
        /// </summary>
        /// <param name="method">oCh\ǂ肷郁\bh</param>
        /// <param name="arguments">oChp[^</param>
        /// <returns>w肳ꂽ\bhw肳ꂽp[^ňoCh\ǂ</returns>
        private static bool IsCompatibleArguments(MethodBase method, object[] arguments)
        {
            ParameterInfo[] paramerterInfos = method.GetParameters();

            if (arguments.Length != paramerterInfos.Length)
            {
                return false;
            }

            for (int i = 0; i < paramerterInfos.Length; ++i)
            {
                if (arguments[i] is NotBoundArgument)
                {
                    continue;
                }
                if (arguments[i] is IArgumentProvider)
                {
                    continue;
                }
                if (!paramerterInfos[i].ParameterType.IsAssignableFrom(arguments[i].GetType()))
                {
                    return false;
                }
            }

            return true;
        }
    }
}
