using System;
using System.Collections;
using System.Reflection;
using Kodama.Function.Functor;

namespace Kodama.Function.Functor.Member
{
    /// <summary>
    /// CX^X\bȟĂяo֐IuWFNgɂ̂ł
    /// </summary>
    /// <remarks>
    /// C++łSTL/Boostmem_funɑ܂B
    /// </remarks>
    /// <example>
    /// <code lang="C#">
    /// 
    /// // ̃NX̃\bhMemberFunctorČĂяo܂
    /// public class TestClass
    /// {
    ///     // ̃\bhMemberFunctorČĂяo܂
    ///     public void Print(string arg1, string arg2, string arg3, string arg4)
    ///     {
    ///         Console.WriteLine(arg1);
    ///         Console.WriteLine(arg2);
    ///         Console.WriteLine(arg3);
    ///         Console.WriteLine(arg4);
    ///     }
    /// }
    ///
    /// // ̊֐ĂԂƁAR\["1"A"2"A"3"A"4"4s\܂
    /// public void MemberFunctorTest()
    /// {
    ///     // MemberFunctor𐶐܂
    ///     IFunctor functor = new MemberFunctor(typeof(TestClass).GetMethod("Print"));
    ///
    ///     // MemberFunctorĂяo܂
    ///     // ̏ꍇAȉ̃R[hƓɂȂ܂B
    ///     //    TestClass ts = new TestClass();
    ///     //    ts.Print("1", "2", "3", "4");
    ///     functor.Invoke(new TestClass(), "1", "2", "3", "4");
    /// }
    /// </code>
    /// </example>
    /// <seealso href="http://boost.cppll.jp/HEAD/">Boostt@X{</seealso>
    public class MemberFunctor : IFunctor
    {
        /// <summary>
        /// MemberFunctorŌĂяoCX^X\bh
        /// </summary>
        MethodBase internalMethod;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="method">MemberFunctorŌĂяoCX^X\bh</param>
        public MemberFunctor(MethodBase method)
        {
            internalMethod = method;
        }

        /// <summary>
        /// ֐IuWFNgfQ[gɕϊĕԂ
        /// </summary>
        /// <returns>֐IuWFNgϊꂽfQ[g</returns>
        public FunctorHandler ConvertToDelegate()
        {
            return new FunctorHandler(Invoke);
        }

        /// <summary>
        /// ֐IuWFNǧĂяo
        /// </summary>
        /// <returns>֐IuWFNg̖̏߂l</returns>
        /// <exception cref="UnmatchArgumentException">̐ƌ^Ȃꍇ̗͂O𓊂</exception>
        public object Invoke()
        {
            throw new UnmatchArgumentException();
        }

        /// <summary>
        /// ֐IuWFNǧĂяo
        /// </summary>
        /// <param name="arguments">֐IuWFNg̏̈</param>
        /// <returns>֐IuWFNg̖̏߂l</returns>
        /// <exception cref="UnmatchArgumentException">̐ƌ^Ȃꍇ̗͂O𓊂</exception>
        public object Invoke(params object[] arguments)
        {
            ParameterInfo[] paramerterInfos = internalMethod.GetParameters();
            if (arguments.Length != paramerterInfos.Length + 1)
            {
                throw new UnmatchArgumentException();
            }
            for (int i = 0; i < paramerterInfos.Length; ++i)
            {
                if (!paramerterInfos[i].ParameterType.IsAssignableFrom(arguments[i + 1].GetType()))
                {
                    throw new UnmatchArgumentException();
                }
            }

            object[] memberMethodArgument = new object[arguments.Length - 1];
            for (int i = 0; i < memberMethodArgument.Length; ++i)
            {
                memberMethodArgument[i] = arguments[i + 1];
            }

            return internalMethod.Invoke(arguments[0], memberMethodArgument);
        }
    }
}
