using System;
using System.CodeDom.Compiler;
using System.Collections;
using System.IO;
using System.Reflection;
using Microsoft.JScript;
using Kodama.Script.Engine;
using Kodama.Script.Engine.CodeDom;

namespace Kodama.Script.Engine.CodeDom.JScript
{
    /// <summary>
    /// JScriptGWł
    /// </summary>
    /// <remarks>
    /// ̃NXCodeDom𗘗pĂ܂B
    /// ɗVisual Studio for Application𗘗p̂ł͂ȂA𗘗pĉB
    /// </remarks>
    public class JScriptEngine : IScriptEngine
	{
        /// <summary>
        /// CodeDom̃RpC
        /// </summary>
        private CodeDomProvider provider = new JScriptCodeProvider();

        /// <summary>
        /// XNvg̃AZu
        /// </summary>
        private Assembly scriptAssembly = null;

        /// <summary>
        /// fobO𐶐邩ǂ
        /// </summary>
        private bool generateDebugInfo = false;

        /// <summary>
        /// XNvgQƂAZu
        /// </summary>
        private ArrayList referenceAssemblies = new ArrayList();

        /// <summary>
        /// XNvgR[h
        /// </summary>
        private ArrayList scriptCode = new ArrayList();

        /// <summary>
        /// XNvg̃AZu擾
        /// </summary>
        /// <remarks>
        /// ăXNvg̃^擾łB
        /// </remarks>
        public Assembly ScriptAssembly
        {
            get { return scriptAssembly; }
        }

        /// <summary>
        /// fobO𐶐邩ǂ
        /// </summary>
        public bool GenerateDebugInfo
        {
            get { return generateDebugInfo; }
            set { generateDebugInfo = value; }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        public JScriptEngine()
        {
            AddReference("system.dll");
            AddReference("mscorlib.dll");
            AddReference(Assembly.GetExecutingAssembly().Location);
        }

        /// <summary>
        /// XNvgŎQƂAZuǉ
        /// </summary>
        /// <remarks>
        /// AZu̎QƂ̓RpCOɒǉĂB
        /// </remarks>
        /// <param name="assemblyName">XNvgŎQƂAZu</param>
        public void AddReference(string assemblyName)
        {
            referenceAssemblies.Add(assemblyName);
        }

        /// <summary>
        /// XNvg݂O[oȃCX^Xǉ
        /// </summary>
        /// <remarks>
        /// O[oȃCX^X̓RpCOɒǉĂB
        /// </remarks>
        /// <param name="name">XNvgQƂƂɂCX^X</param>
        /// <param name="obj">XNvgɒǉO[oȃCX^X</param>
        /// <exception cref="NotSupportedException">
        /// CodeDomł̓O[oȃCX^XT|[gĂȂ̂ŕK̗O܂
        /// </exception>
        public void AddGlobalIntstance(string name, object obj)
        {
            throw new NotSupportedException();
        }

        /// <summary>
        /// XNvgt@CǂݏoAɂR[hɒǉ
        /// </summary>
        /// <param name="filename">XNvgt@C</param>
        public void AddScriptCodeFromFile(string filename)
        {
            StreamReader reader = new StreamReader(filename);
            string code = reader.ReadToEnd();
            reader.Close();
            scriptCode.Add(code);
        }

        /// <summary>
        /// eLXgɂR[hɒǉ
        /// </summary>
        /// <param name="name">XNvg</param>
        /// <param name="code">ǉeLXg</param>
        public void AddScriptCodeFromText(string name, string code)
        {
            scriptCode.Add(code);
        }

        /// <summary>
        /// XNvgRpC
        /// </summary>
        /// <exception cref="CompileErrorException">
        /// RpCG[ꍇ̗͂O𓊂
        /// </exception>
        public void Compile()
        {
            ICodeCompiler compiler = provider.CreateCompiler();

            CompilerParameters compilerParams = new CompilerParameters();
            foreach (string assembly in referenceAssemblies)
            {
                compilerParams.ReferencedAssemblies.Add(assembly);
            }
            compilerParams.GenerateInMemory        = true;
            compilerParams.GenerateExecutable      = true;
            compilerParams.IncludeDebugInformation = generateDebugInfo;

            CompilerResults result = compiler.CompileAssemblyFromSourceBatch
                (compilerParams, (string[])scriptCode.ToArray(typeof(string)));   
            foreach (CompilerError error in result.Errors)
            {
                if (!error.IsWarning)
                {
                    throw new CodeDomCompileErrorException(result);
                }
            }

            scriptAssembly = result.CompiledAssembly;
        }

        /// <summary>
        /// XNvgs
        /// </summary>
        /// <exception cref="ScriptEntryPointNotFoundException">
        /// Gg[|Cg݂Ȃꍇ̗͂O𓊂
        /// </exception>
        /// <exception cref="NotCompiledException">
        /// XNvgRpCĂȂꍇ̗͂O𓊂
        /// </exception>
        public void Run()
        {
            if (scriptAssembly == null)
            {
                throw new NotCompiledException();
            }

            MethodInfo mi = scriptAssembly.EntryPoint;
            if (mi == null)
            {
                throw new ScriptEntryPointNotFoundException();
            }
            mi.Invoke(null, new object[] {new string[] {}});
        }

        /// <summary>
        /// XNvg̎s~
        /// </summary>
        public void Stop()
        {
            // ɂȂ
        }

        /// <summary>
        /// XNvg̃\[XJAXNvgGW𖳌ɂ
        /// </summary>
        /// <remarks>
        /// IXNvgGW͂̃\bhĂяoĂB
        /// </remarks>
        public void Close()
        {
            // ɂȂ
        }
    }
}
